/*
 * Copyright 1999-2003 by NeTraverse Inc.
 * This source code is provided "AS IS", free of charge
 * and without restrictions.
 * NeTraverse (and it's third party suppliers and licensors) make no warranty
 * to its use, performance, or suitability for any particular purpose.
 * In no event, shall NeTraverse (and it's third party suppliers and licensors)
 * be liable for any damages resulting in the use of this source code.
 * The entire risk arising out of the use of this source code remains
 * with you.
 *
 ***********************************************************************
 *  This software may be used and distributed according to the terms
 *  of the GNU General Public License, incorporated herein by reference.
 */
/*
 * These hooks will get populated by the mki-adapter module
 */

#include <linux/config.h>
#include <linux/version.h>
#include <linux/module.h>
#include <linux/types.h>
#include <linux/spinlock.h>

#include <asm/system.h>
#include <asm/mki.h>
#include <asm/mkiversion.h>
#ifdef CONFIG_X86_PAE
#include <asm/page.h>
EXPORT_SYMBOL_NOVERS(__supported_pte_mask);
#endif	/* CONFIG_X86_PAE */

/* if CONFIG_REGPARM is set, stop right here; this option is not compatible
 * with Win4Lin */
#ifdef CONFIG_REGPARM
#error The kernel option CONFIG_REGPARM is not compatible with Win4Lin.
#error Please turn it off, reconfigure, and try to build again.
#endif	/* CONFIG_REGPARM */

char mki_ver[] = "mki_version_3_1_2";

void mhi_void_hook(void *parm1, void *parm2)
{
	return;
}

void (*mhi_hooks[])(void *, void *) =
{
	&mhi_void_hook, /* MKI_HOOK_RET_USER */
	&mhi_void_hook, /* MKI_HOOK_SWITCH_TO */
	&mhi_void_hook, /* MKI_HOOK_SWITCH_AWAY */
	&mhi_void_hook, /* MKI_HOOK_EXIT */
	&mhi_void_hook, /* MKI_HOOK_SWAP */
};

void mki_ret_user(void * regs)
{
	CALL_MKI_HOOK(MKI_HOOK_RET_USER, regs, NULL);
}

EXPORT_SYMBOL_NOVERS(mhi_void_hook);
EXPORT_SYMBOL_NOVERS(mhi_hooks);
EXPORT_SYMBOL_NOVERS(mki_ret_user);
extern void mki_process_trapret(void);
EXPORT_SYMBOL_NOVERS(mki_process_trapret);

//some data that we need for the other modules
#include <linux/sched.h>
#include <asm/processor.h>
#include <asm/desc.h>

extern struct desc_struct idt_table[];

EXPORT_SYMBOL_NOVERS(per_cpu__init_tss);
EXPORT_SYMBOL_NOVERS(idt_table);
EXPORT_SYMBOL_NOVERS(idt_descr);
EXPORT_SYMBOL_NOVERS(cpu_gdt_descr);
EXPORT_SYMBOL_NOVERS(mmu_cr4_features);

//and some functions
#include <linux/mm.h>
EXPORT_SYMBOL_NOVERS(handle_mm_fault);
EXPORT_SYMBOL_NOVERS(make_pages_present);
#ifdef CONFIG_SMP
EXPORT_SYMBOL_NOVERS(mki_kick_if_running);
extern void flush_tlb_all(void);
EXPORT_SYMBOL_NOVERS(flush_tlb_all);
#endif

EXPORT_SYMBOL_NOVERS(__pmd_alloc);
EXPORT_SYMBOL_NOVERS(pte_alloc_map);

#include <asm/uaccess.h>
EXPORT_SYMBOL_NOVERS(search_exception_tables);
extern asmlinkage int sys_mprotect(unsigned long, size_t, unsigned long);
EXPORT_SYMBOL_NOVERS(sys_mprotect);
extern asmlinkage long sys_ftruncate(int, unsigned long);
EXPORT_SYMBOL_NOVERS(sys_ftruncate);
extern asmlinkage int sys_munmap(unsigned long, size_t);
EXPORT_SYMBOL_NOVERS(sys_munmap);
/* asmlinkage NORET_TYPE void do_exit(long error_code) ATTRIB_NORET;*/ /*2.6.10*/
EXPORT_SYMBOL_NOVERS(do_exit);
