/* 
 * Copyright 1999-2003 by NeTraverse Inc.
 * This source code is provided "AS IS", free of charge 
 * and without restrictions.
 * NeTraverse (and it's third party suppliers and licensors) make no warranty
 * to its use, performance, or suitability for any particular purpose.
 * In no event, shall NeTraverse (and it's third party suppliers and licensors)
 * be liable for any damages resulting in the use of this source code.
 * The entire risk arising out of the use of this source code remains
 * with you.
 * 
 ***********************************************************************
 *  This software may be used and distributed according to the terms
 *  of the GNU General Public License, incorporated herein by reference.
 */


#ifdef CONFIG_MKI
#ifndef INCLUDE_MKI_H
#define INCLUDE_MKI_H

extern void mhi_void_hook(void *, void *);
extern void (*mhi_hooks[])(void *, void *);
extern void mki_ret_user(void *regs);

#define CALL_MKI_HOOK(hook, arg1, arg2)  mhi_hooks[hook](arg1, arg2)

/* for mki-adapter module */
#define MKI_HOOK_TABLE_EXISTS	1

#ifdef CONFIG_SMP
/*
 * For mki-adapter: this version of the MKI has a mki_kick_if_running()
 * function.
 */
#define MKI_HAS_MKI_KICK_IF_RUNNING    1
extern void mki_kick_if_running(struct task_struct *);
#endif /* CONFIG_SMP */


/* constants for hook table  */
#define MKI_HOOK_RET_USER 		0
#define MKI_HOOK_SWITCH_TO 		1
#define MKI_HOOK_SWITCH_AWAY 		2
#define MKI_HOOK_EXIT			3
#define MKI_HOOK_SWAP			4

#define MKI_HARD_PRIORITY 	1
#define MKI_NORMAL_PRIORITY 	6

#endif /* INCLUDE_MKI_H */
#endif /* CONFIG_MKI */
